#pragma once

#include "Block.h"
#include "DefaultEventListener.h"

#include <Vec3.h>
#include <Array.h>
#include <Datei.h>
#include <Punkt.h>

class Chunk : public EventThrower
{
private:
    Block **blocks;
    Framework::Punkt location;
    Framework::RCArray<Event> events;
    Chunk *neighbours[ 4 ];

public:
    Chunk( Framework::Punkt location );
    Block *getBlockAt( Framework::Vec3<int> location );
    void putBlockAt( Framework::Vec3<int> location, Block *block );
    void setNeighbor( Chunk *zChunk );
    virtual void tick();
    virtual void postTick();
};